System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = SettingsClosed;
System.Gadget.Flyout.file = "ChannelFlyout.html";

var getStationIntervalID = 0;
var chanList = "";
var yummycookie = "";
var yummycookie2 = "";
var sillytempcookiearray = "";
var timer = null;
var timerInterval = 10000; // updates song info every 10 seconds
var currentChannel = 0;
var loggedon = false;
var connspeed = 'high';
var wdgtVer = 1.1;
var favsave = 0;
var qtID = 0;
var savemode = 0;
var muzacvolume = 50;
var debug = false;

function alert(msg) {
    if (debug) {
        System.Debug.outputString(msg);
    }
}
function SettingsClosed() {
    document.getElementById("chanArtist").innerHTML = "";
    document.getElementById("chanAlbum").innerHTML = "";
    document.getElementById("chanLogo").innerHTML = "";
    document.getElementById("chanSong").innerHTML = "";
    document.getElementById("stopbutton").innerHTML = "";
    document.getElementById("infobutton").innerHTML = "";
    document.getElementById("logstatus").innerHTML = "<font color='#ffd51e'>Working...</font>";
    goLogon();
}

function changestation(elem) {
    getStation(parseInt(elem.options[elem.selectedIndex].value));
}

function changetostation(chan) {
    System.Gadget.Flyout.show = false;
    getStation(parseInt(chan));
}

function getStation(chanID) {
    url = 'http://player.xmradio.com/player/2ft/playMedia.jsp?ch=' + chanID + '&speed=' + connspeed;
    req = new XMLHttpRequest();
    req.open("get", url, true);
    req.setRequestHeader("Cookie", "playspeed=" + connspeed + "; lastview=allchannels; pad_user=yes; uiType=genericweb; " + yummycookie);
    req.onreadystatechange = processStationPart1;
    req.send(null);
    currentChannel = chanID;
    document.getElementById("stopbutton").innerHTML = "<a onclick='stopplaying();' border='0'>Stop</a>";
}

function processStationPart1() {
    if (null == req.readyState) return;
    if (req.readyState == 4) {
        if (req.status == 200) {
            var cookie_array = req.getResponseHeader("Set-Cookie").split(";");
            yummycookie = cookie_array[0];
            PlayerPage = req.responseText;
            var metaIsThere = PlayerPage.indexOf('metafile.jsp');

            if (metaIsThere > -1) {

                var step1_array = PlayerPage.split("metafile.jsp?");
                var step2_array = step1_array[1].split('" name');
                var step3_array = step2_array[0].split('"');
                var player = document.getElementById("player");
                url2 = "http://player.xmradio.com/hotstream/metafile.jsp?" + step2_array[0];
                req2 = new XMLHttpRequest();
                req2.open("get", url2, true);
                req2.onreadystatechange = processStationPart2;
                req2.setRequestHeader("Cookie", "pad_user=yes; " + yummycookie + "uiType=genericweb; hotstream=true");
                req2.send(null);

                document.getElementById("mplayer").innerHTML = '<EMBED type="application/x-mplayer2" pluginspage="http://www.microsoft.com/Windows/MediaPlayer/" SRC="' + url2 + '" name="xmmediaplayer" width="200" height="25" autostart="1" ShowControls="0" ShowStatusBar="0" ShowDisplay="0" showtracker="0" SendPlayStateChangeEvents="1" transparentAtStart="0" autoSize="0" displaySize="0"></EMBED>';
                getStationInfo();
            }
        } else {
            if (null == req.status) return;
        }
    }
}

function processStationPart2() {
    if (null == req2.readyState) return;
    if (req2.readyState == 4) {
        if (req2.status == 200) {
            var audioPage = req2.responseText;

            if (audioPage.indexOf('mms:') > -1) {
                var astep1_array = audioPage.split('<Ref href="');
                var astep2_array = astep1_array[1].split('"/>');
                var audioURL = astep2_array[0];
                getStationInfo();
                document.getElementById("chanlogo").innerHTML = '<embed id="flashlogo" height="50" Width="97" SALIGN="BR" wmode="transparent"  src="http://player.xmradio.com/player/_logos/' + currentChannel + '.swf"></embed>';
                qtID = '0';
            }
        } else {
            if (null == req2.status) return;
        }
    }
}

function buildMyChans() {
    url = 'http://player.xmradio.com/player/2ft/channelData.jsp';
    chanreq = new XMLHttpRequest();
    chanreq.onreadystatechange = processBuildChans;
    chanreq.open("get", url, true);
    chanreq.setRequestHeader("Cookie", 'lastview=allchannels; ' + yummycookie2 + '; uiType=genericweb; ' + yummycookie + '; pad_user=yes; hotstream=true');
    chanreq.send(null);
}

function processBuildChans() {
    if (null == chanreq.readyState) return;
    if (chanreq.readyState == 4) {
        if (chanreq.status == 200) {
            ChansPage = chanreq.responseText;
            var temp = String(ChansPage);
            chanList = "<table><tr><td colspan='2'>XM Radio Channels - click to select</td></tr>";
            var chanData = "";
            var chanNum = "";
            var chanName = "";
            var chanDesc = "";
            var cstylel = "";
            var cstyled = "";
            var nhoods = temp.split('{\"channels\":[');
            for (i = 1; i < nhoods.length; i++) {
                var nchans = nhoods[i].split('}],\"nhood\":');
                temp = nchans[1].split('"');
                hoodName = temp[1];
                switch (hoodName) {
                    case "XM Exclusives":
                        cstylel = "xmexclusivesch-light";
                        cstyled = "xmexclusivesch-dark";
                        break
                    case "Decades":
                        cstylel = "decadesch-light";
                        cstyled = "decadesch-dark";
                        break
                    case "Country":
                        cstylel = "countrych-light";
                        cstyled = "countrych-dark";
                        break
                    case "Pop":
                        cstylel = "pophitsch-light";
                        cstyled = "pophitsch-dark";
                        break
                    case "Christian":
                        cstylel = "christianch-light";
                        cstyled = "christianch-dark";
                        break
                    case "Rock":
                        cstylel = "rockch-light";
                        cstyled = "rockch-dark";
                        break
                    case "Hip-Hop & R&B":
                        cstylel = "hiphopurbanch-light";
                        cstyled = "hiphopurbanch-dark";
                        break
                    case "Jazz & Blues":
                        cstylel = "jazzbluesch-light";
                        cstyled = "jazzbluesch-dark";
                        break
                    case "Entertainment":
                        cstylel = "lifestylech-light";
                        cstyled = "lifestylech-dark";
                        break
                    case "Dance":
                        cstylel = "dancech-light";
                        cstyled = "dancech-dark";
                        break
                    case "Latin & World":
                        cstylel = "latinch-light";
                        cstyled = "latinch-dark";
                        break
                    case "World":
                        cstylel = "worldch-light";
                        cstyled = "worldch-dark";
                        break
                    case "Classical":
                        cstylel = "classicalch-light";
                        cstyled = "classicalch-dark";
                        break
                    case "Kids":
                        cstylel = "kidsch-light";
                        cstyled = "kidsch-dark";
                        break
                    case "Sports":
                        cstylel = "newsch-light";
                        cstyled = "newsch-dark";
                        break
                    case "Comedy":
                        cstylel = "comedych-light";
                        cstyled = "comedych-dark";
                        break
                    case "Talk, News, NPR":
                        cstylel = "talkch-light";
                        cstyled = "talkch-dark";
                        break
                    case "AOL Radio":
                        cstylel = "aolradioch-light";
                        cstyled = "aolradioch-dark";
                        break
                    default:
                        cstylel = "countrych-light";
                        cstyled = "countrych-dark";
                }
                chanList = chanList + "<tr><td class='" + cstyled + "' colspan='2'>" + hoodName + "</td></tr>";

                nchans = nchans[0].split('},');
                for (chanNdx = 0; chanNdx < nchans.length; chanNdx++) {
                    var chanData = nchans[chanNdx].replace(/{/g, '').split(',');
                    if (chanData[0].search(/true/i) != -1) {
                        // get the channel name
                        temp = chanData[1].split(':');
                        chanName = temp[1].replace(/"/g, '');
                        // get the channel number
                        temp = chanData[2].split(':');
                        chanNum = parseInt(temp[1]);
                        // get the channel description
                        temp = chanData[3].split(':');
                        chanDesc = temp[1].replace(/"/g, '');
                        chanList = chanList + "<tr><td class='" + cstyled + "' align='right'>" + chanNum + "</td><td onclick='System.Gadget.document.parentWindow.changetostation(" + chanNum + ");' class='" + cstylel + "'>" + chanName + "</td></tr>";
                    }
                }
            }
            document.getElementById("chanSelector").innerHTML = "<a onclick='showChanList();' border='0'>Channel&#177;</a>";
            document.getElementById("logstatus").innerHTML = "";
        } else {
            document.getElementById("logstatus").innerHTML = "<font color='red'>Timeout on channel list.</font>";
            if (null == chanreq.status) return;
        }
    }
}

function getStationInfo() {
    if (loggedon == true) {
        if (currentChannel != '0') {
            getStationInfo2();
            document.getElementById("chanArtist").innerHTML = "Getting info...";
            document.getElementById("chanSong").innerHTML = "";
            document.getElementById("chanAlbum").innerHTML = "";
            document.getElementById("infobutton").innerHTML = "<a onclick='getStationInfo();'>Playing...</a>";
            getStationIntervalID = setInterval("getStationInfo2()", timerInterval);
        }
    }
}

function getStationInfo2() {
    siurl = 'http://player.xmradio.com/padData/pad_data_servlet.jsp?all_channels=true&remote=true&rpc=NAPS';
    sireq = new XMLHttpRequest();
    sireq.onreadystatechange = processStationInfo;
    sireq.open("get", siurl, true);
    sireq.setRequestHeader("Cookie", 'pad_user=yes; ' + yummycookie + '; uiType=genericweb; hotstream=true');
    sireq.send(null);
}

function ellipse(string2trim) {
    if (string2trim.length > 20) {
        return (string2trim.substring(0, 19) + "...");
    } else {
        return (string2trim);
    }
}

function processStationInfo() {
    if (null == sireq.readyState) return;
    if (sireq.readyState == 4) {
        if (sireq.status == 200) {

            SIPage = sireq.responseText;
            a = SIPage.indexOf('num: ' + currentChannel + ',');
            tempSI = SIPage.substring(a);
            var tempSI_array = tempSI.split(',');
            var tempSI2_array = tempSI_array[1].split('"');
            document.getElementById("chanArtist").innerHTML = ellipse(tempSI2_array[1]);
            var tempSI3_array = tempSI_array[2].split('"');
            document.getElementById("chanSong").innerHTML = ellipse(tempSI3_array[1]);
            var tempSI4_array = tempSI_array[3].split('"');
            document.getElementById("chanAlbum").innerHTML = '<a href="http://www.amazon.com/gp/search?ie=UTF8&node=163856011&keywords=' + tempSI4_array[1].replace(" ", "%20") + '+' + tempSI2_array[1].replace(" ", "%20") + '&tag=03201960-20&index=music">' + ellipse(tempSI4_array[1]) + '</a>';
            document.getElementById("chanlogo").innerHTML = '<embed id="flashlogo" height="50" Width="97" SALIGN="BR" wmode="transparent"  src="http://player.xmradio.com/player/_logos/' + currentChannel + '.swf"></embed>';
            document.getElementById("logstatus").innerHTML = '<a href="http://www.amazon.com/gp/search?ie=UTF8&node=163856011&keywords=' + tempSI4_array[1].replace(" ", "%20") + '+' + tempSI2_array[1].replace(" ", "%20") + '&tag=03201960-20&index=music">Get @ Amazon</a>';
        } else {
            if (null == sireq.status) return;
            document.getElementById("chanArtist").innerHTML = "We waited";
            document.getElementById("chanSong").innerHTML = "and still";
            document.getElementById("chanAlbum").innerHTML = "nothing came.";
        }
    }
}

function sendRequest(data) {
    header = 'Content-Type:application/x-www-form-urlencoded; charset=UTF-8';
    objhttp = new XMLHttpRequest();
    // open socket connection
    objhttp.open("post", 'http://xmro.xmradio.com/xstream/login_servlet.jsp', true);
    // set http header
    objhttp.setRequestHeader(header.split(':')[0], header.split(':')[1]);
    //set what to do wehn it gets data
    objhttp.onreadystatechange = processSendRequestChange;
    // send data
    objhttp.send(data);
}

function processSendRequestChange() {
    if (null == objhttp.readyState) return;
    if (objhttp.readyState == 4) {
        if (objhttp.status == 200) {
            PageReturned = objhttp.responseText;
            var launchXMRO = PageReturned.indexOf('launchXMRO');
            if (launchXMRO > -1) {
                var cookie_array = objhttp.getResponseHeader("Set-Cookie").split(";");
                yummycookie = cookie_array[0];
                var userinfo_array = cookie_array[0].split("|");
                var useremail_array = userinfo_array[0].split("=");
                document.getElementById("RealFullName").innerHTML = userinfo_array[7] + " " + userinfo_array[8];
                document.getElementById("RadioID").innerHTML = userinfo_array[9];
                document.getElementById("emailaddress").innerHTML = useremail_array[1];
                loggedon = true;
                document.getElementById("logstatus").innerHTML = "<font color='#ffd51e'>Building Channels...</font>";
                buildMyChans();
            }
            else {
                document.getElementById("logstatus").innerHTML = "<font color='#ff0000'>Invalid Login</font>";
            }
        }
        else {
            document.getElementById("chanArtist").innerHTML = "<font color='#ff0000'>Timeout - Retry</font>";
            if (null == objhttp.status) return;
        }
    }
}

function goLogon() {
    document.getElementById("logstatus").innerHTML = "<font color='#ffd51e'>Working...</font>";
    var userName = System.Gadget.Settings.read("username");
    var userPWD = System.Gadget.Settings.read("password");
    userName = userName.replace("@", "%40");
    if (!userName) { userName = 'IamDumb' };
    if (!userPWD) { userPWD = 'eeeks' };
    sendRequest('confcode=&user_id=' + userName + '&pword=' + userPWD + '&go.x=8&go.y=9&userForward=default');
}

function goLogoff() {
    document.getElementById("RealFullName").innerHTML = '';
    document.getElementById("RadioID").innerHTML = '';
    document.getElementById("emailaddress").innerHTML = '';
    document.getElementById("logstatus").innerHTML = "<font color='Blue'>Logged Off</font>";
    loggedon = false;
    setup();
    document.getElementById('Logon').style.display = 'block';
    document.getElementById('logoninfo').style.display = 'block';
    document.getElementById("chanArtist").innerHTML = "Login (Settings)";
    document.getElementById("chanSong").innerHTML = "";
    document.getElementById("chanAlbum").innerHTML = "";
    document.getElementById("title").innerHTML = '<h3>XMRadio</h3>';
    document.getElementById("chanlogo").innerHTML = "";
}

function stopplaying() {

    document.getElementById("mplayer").innerHTML = '<EMBED type="application/x-mplayer2" pluginspage="http://www.microsoft.com/Windows/MediaPlayer/" SRC="" name="xmmediaplayer" width="200" height="25" autostart="1" ShowControls="0" ShowStatusBar="0" ShowDisplay="0" showtracker="0" SendPlayStateChangeEvents="1" transparentAtStart="0" autoSize="0" displaySize="0"></EMBED>';
    clearInterval(getStationIntervalID);
    document.getElementById("infobutton").innerHTML = "<a onclick='getStationInfo();'>Stopped...</a>";
    document.getElementById("stopbutton").innerHTML = "<a onclick='getStation(" + currentChannel + ");' border='0'>Play</a>";
    document.getElementById("chanArtist").innerHTML = "";
    document.getElementById("chanSong").innerHTML = "";
    document.getElementById("chanAlbum").innerHTML = "";
}

function showChanList() {
    chanList = chanList + "</table>";
    System.Gadget.Flyout.show = true;
}



